/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// clientUrl - A base url to send rest events to (optional).    autoStartSipServer - When set, starts the sip server automatically with the service.    sipParams - Sip server configuration, see ConfigSipServerParams for more details.    smppParams - Smpp client configuration, see ConfigSmppParams for more details.
    /// </summary>
    [DataContract]
        public partial class ConfigParams :  IEquatable<ConfigParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ConfigParams" /> class.
        /// </summary>
        /// <param name="serviceParams">serviceParams.</param>
        /// <param name="sipParams">sipParams.</param>
        /// <param name="smppParams">smppParams.</param>
        public ConfigParams(ConfigServiceParams serviceParams = default(ConfigServiceParams), ConfigSipParams sipParams = default(ConfigSipParams), ConfigSmppParams smppParams = default(ConfigSmppParams))
        {
            this.ServiceParams = serviceParams;
            this.SipParams = sipParams;
            this.SmppParams = smppParams;
        }
        
        /// <summary>
        /// Gets or Sets ServiceParams
        /// </summary>
        [DataMember(Name="serviceParams", EmitDefaultValue=false)]
        public ConfigServiceParams ServiceParams { get; set; }

        /// <summary>
        /// Gets or Sets SipParams
        /// </summary>
        [DataMember(Name="sipParams", EmitDefaultValue=false)]
        public ConfigSipParams SipParams { get; set; }

        /// <summary>
        /// Gets or Sets SmppParams
        /// </summary>
        [DataMember(Name="smppParams", EmitDefaultValue=false)]
        public ConfigSmppParams SmppParams { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ConfigParams {\n");
            sb.Append("  ServiceParams: ").Append(ServiceParams).Append("\n");
            sb.Append("  SipParams: ").Append(SipParams).Append("\n");
            sb.Append("  SmppParams: ").Append(SmppParams).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ConfigParams);
        }

        /// <summary>
        /// Returns true if ConfigParams instances are equal
        /// </summary>
        /// <param name="input">Instance of ConfigParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ConfigParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ServiceParams == input.ServiceParams ||
                    (this.ServiceParams != null &&
                    this.ServiceParams.Equals(input.ServiceParams))
                ) && 
                (
                    this.SipParams == input.SipParams ||
                    (this.SipParams != null &&
                    this.SipParams.Equals(input.SipParams))
                ) && 
                (
                    this.SmppParams == input.SmppParams ||
                    (this.SmppParams != null &&
                    this.SmppParams.Equals(input.SmppParams))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ServiceParams != null)
                    hashCode = hashCode * 59 + this.ServiceParams.GetHashCode();
                if (this.SipParams != null)
                    hashCode = hashCode * 59 + this.SipParams.GetHashCode();
                if (this.SmppParams != null)
                    hashCode = hashCode * 59 + this.SmppParams.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
